from org.codehaus.jettison.json import JSONObject, JSONArray
import sys;
from utilities import Util

__name_att__ = None;

def export(objid, parentcontainmentpath, parentrespath):

  name = "DiskCacheCustomPerformanceSettings";

  containmentpath = "%(parentconpath)sDiskCacheCustomPerformanceSettings:/" % {'parentconpath':parentcontainmentpath }
  if not containmentpath.startswith("/"):
    containmentpath = "/" + containmentpath;

  dict = _export(objid, parentrespath, name);
  dict['conpath'] = containmentpath;
  return dict

def _export(objid, parentrespath, name = ""):
  Util.pushPathElement('DiskCacheCustomPerformanceSettings')


  if parentrespath == "/":
    parentrespath = "";
  respath = "%(parentrespath)s/%(name)s" % { 'parentrespath':parentrespath, 'name':name }
  if not respath.startswith("/"):
    respath = "/" + respath;

  exportedObject = JSONObject();
  exportedObject.put("name", name);
  exportedObject.put("path", respath);
  exportedObject.put("teamMappings", JSONArray());
  exportedObject.put("inheritTeam", "true");
  exportedObject.put("description", "Discovered WebSphereDiskCacheCustomPerformanceSettings");
  exportedObject.put("roleName", "WebSphereDiskCacheCustomPerformanceSettings");

  roleProperties = JSONObject();

  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.diskcachecustomperformancesettings.maxbufferedtemplates", objid, "maxBufferedTemplates","DiskCacheCustomPerformanceSettings");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.diskcachecustomperformancesettings.maxbuffereddependencyids", objid, "maxBufferedDependencyIds","DiskCacheCustomPerformanceSettings");
  Util.addAttributeToJsonIfNotNone(roleProperties, "websphere.diskcachecustomperformancesettings.maxbufferedcacheidspermetaentry", objid, "maxBufferedCacheIdsPerMetaEntry","DiskCacheCustomPerformanceSettings");
  exportedObject.put("roleProperties", roleProperties);
  result = { 'object': exportedObject, 'respath':respath }
  extraObjects = [];
  if len(extraObjects) != 0:
    result['extraObjects'] = extraObjects;
  Util.popPathElement('DiskCacheCustomPerformanceSettings');
  return result;

def doImport(containmentpath, roleName, jsonobject):
  if not jsonobject.has("roleProperties"):
    raise Exception("DiskCacheCustomPerformanceSettings resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  objid = Util.getid(containmentpath);
  if objid == None or len(objid) == 0:
    index = containmentpath.rindex('/',0,len(containmentpath)-2)+1;
    parentconpath = containmentpath[0:index];
    parentid = Util.getid(parentconpath);
    if parentid == None or len(parentid) == 0:
      raise Exception("Parent does not exist to create DiskCacheCustomPerformanceSettings on.");
    objid = create(parentid, jsonobject);
  else:
    update(objid,jsonobject);
  return objid;

def create(parentid, jsonobject):
  Util.pushPathElement('DiskCacheCustomPerformanceSettings')
  if not jsonobject.has("roleProperties"):
    raise Exception("DiskCacheCustomPerformanceSettings resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  properties = [];
  Util.addIfNotNone(properties, "maxBufferedTemplates", roleProperties.optString("websphere.diskcachecustomperformancesettings.maxbufferedtemplates", None));
  Util.addIfNotNone(properties, "maxBufferedDependencyIds", roleProperties.optString("websphere.diskcachecustomperformancesettings.maxbuffereddependencyids", None));
  Util.addIfNotNone(properties, "maxBufferedCacheIdsPerMetaEntry", roleProperties.optString("websphere.diskcachecustomperformancesettings.maxbufferedcacheidspermetaentry", None));
  print "Creating DiskCacheCustomPerformanceSettings with attributes";
  for prop in properties:
    print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };
  objid = Util.create("DiskCacheCustomPerformanceSettings", parentid, properties);
  Util.popPathElement('DiskCacheCustomPerformanceSettings');
  return objid;

def update(objid,jsonobject):
  Util.pushPathElement('DiskCacheCustomPerformanceSettings')
  if not jsonobject.has("roleProperties"):
    raise Exception("DiskCacheCustomPerformanceSettings resource has no role properties!");

  roleProperties = jsonobject.getJSONObject("roleProperties");

  atts = [];
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.diskcachecustomperformancesettings.maxbufferedtemplates", None), "maxBufferedTemplates","DiskCacheCustomPerformanceSettings");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.diskcachecustomperformancesettings.maxbuffereddependencyids", None), "maxBufferedDependencyIds","DiskCacheCustomPerformanceSettings");
  Util.addAttIfChanged(objid, atts, roleProperties.optString("websphere.diskcachecustomperformancesettings.maxbufferedcacheidspermetaentry", None), "maxBufferedCacheIdsPerMetaEntry","DiskCacheCustomPerformanceSettings");
  if len(atts) != 0:
    print "Modifying DiskCacheCustomPerformanceSettings with attributes:"
    for prop in atts:
      print "%(name)s = %(value)s" % { 'name': prop[0], 'value': prop[1] };

    Util.modify(objid, atts);
  else:   
    print "DiskCacheCustomPerformanceSettings configuration up to date.";

  Util.popPathElement('DiskCacheCustomPerformanceSettings');
